---
title: XMLHttpRequest.response
slug: Web/API/XMLHttpRequest/response
tags:
  - AJAX
  - API
  - Fetching Content
  - Fetching Data
  - Loading Data
  - Property
  - Read-only
  - Reading Data
  - Reference
  - Response
  - Server
  - XMLHttpRequest
---
<div>{{APIRef('XMLHttpRequest')}}</div>

<p><span class="seoSummary">The {{domxref("XMLHttpRequest")}} <code><strong>response</strong></code> property returns the response's body content as an {{domxref("ArrayBuffer")}}, {{domxref("Blob")}}, {{domxref("Document")}}, JavaScript {{jsxref("Object")}}, or {{domxref("DOMString")}}, depending on the value of the request's {{domxref("XMLHttpRequest.responseType", "responseType")}} property.</span></p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var <em>body</em> = <em>XMLHttpRequest</em>.response;
</pre>

<h3 id="Value">Value</h3>

<p>An appropriate object based on the value of {{domxref("XMLHttpRequest.responseType", "responseType")}}. You may attempt to request the data be provided in a specific format by setting the value of <code>responseType</code> after calling {{domxref("XMLHttpRequest.open", "open()")}} to initialize the request but before calling {{domxref("XMLHttpRequest.send", "send()")}} to send the request to the server.</p>

<p>The value is <code>null</code> if the request is not yet complete or was unsuccessful, with the exception that when reading text data using a <code>responseType</code> of <code>"text"</code> or the empty string (<code>""</code>), the response can contain the response so far while the request is still in the <code>LOADING</code> {{domxref("XMLHttpRequest.readyState", "readyState")}} (3).</p>

<p>The response types are described below.</p>

<p>{{page("/en-US/docs/Web/API/XMLHttpRequestResponseType", "Values")}}</p>

<h2 id="Example">Example</h2>

<p>This example presents a function, <code>load()</code>, which loads and processes a page from the server. It works by creating an {{domxref("XMLHttpRequest")}} object and creating a listener for {{event("readystatechange")}} events such that when <code>readyState</code> changes to <code>DONE</code> (4), the <code>response</code> is obtained and passed into the callback function provided to <code>load()</code>.</p>

<p>The content is handled as raw text data (since nothing here is overriding the default {{domxref("XMLHttpRequest.responseType", "responseType")}}).</p>

<pre class="brush: js">var url = 'somePage.html'; //A local page

function load(url, callback) {
  var xhr = new XMLHttpRequest();

  xhr.onreadystatechange = function() {
    if (xhr.readyState === 4) {
      callback(xhr.response);
    }
  }

  xhr.open('GET', url, true);
  xhr.send('');
}

</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('XMLHttpRequest', '#the-response-attribute')}}</td>
   <td>{{Spec2('XMLHttpRequest')}}</td>
   <td>WHATWG living standard</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.XMLHttpRequest.response")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/XMLHttpRequest/Using_XMLHttpRequest">Using XMLHttpRequest</a></li>
 <li>Getting text and HTML/XML data: {{domxref("XMLHttpRequest.responseText")}} and {{domxref("XMLHttpRequest.responseXML")}}</li>
</ul>
